/* valainitializerlist.c generated by valac, the Vala compiler
 * generated from valainitializerlist.vala, do not modify */

/* valainitializerlist.vala
 *
 * Copyright (C) 2006-2011  Jürg Billeter
 * Copyright (C) 2006-2008  Raffaele Sandrini
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 * 	Raffaele Sandrini <raffaele@sandrini.ch>
 */

#include "vala.h"
#include <valagee.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _vala_iterator_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterator_unref (var), NULL)))

struct _ValaInitializerListPrivate {
	ValaList* initializers;
};

static gint ValaInitializerList_private_offset;
static gpointer vala_initializer_list_parent_class = NULL;

static void vala_initializer_list_real_accept_children (ValaCodeNode* base,
                                                 ValaCodeVisitor* visitor);
static void vala_initializer_list_real_accept (ValaCodeNode* base,
                                        ValaCodeVisitor* visitor);
static gboolean vala_initializer_list_real_is_constant (ValaExpression* base);
static gboolean vala_initializer_list_real_is_pure (ValaExpression* base);
static gboolean vala_initializer_list_real_is_accessible (ValaExpression* base,
                                                   ValaSymbol* sym);
static gchar* vala_initializer_list_real_to_string (ValaCodeNode* base);
static void vala_initializer_list_real_replace_expression (ValaCodeNode* base,
                                                    ValaExpression* old_node,
                                                    ValaExpression* new_node);
static gboolean vala_initializer_list_real_check (ValaCodeNode* base,
                                           ValaCodeContext* context);
static void vala_initializer_list_real_emit (ValaCodeNode* base,
                                      ValaCodeGenerator* codegen);
static void vala_initializer_list_real_get_used_variables (ValaCodeNode* base,
                                                    ValaCollection* collection);
static void vala_initializer_list_finalize (ValaCodeNode * obj);
static GType vala_initializer_list_get_type_once (void);

static inline gpointer
vala_initializer_list_get_instance_private (ValaInitializerList* self)
{
	return G_STRUCT_MEMBER_P (self, ValaInitializerList_private_offset);
}

/**
 * Appends the specified expression to this initializer
 *
 * @param expr an expression
 */
void
vala_initializer_list_append (ValaInitializerList* self,
                              ValaExpression* expr)
{
	ValaList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->initializers;
	vala_collection_add ((ValaCollection*) _tmp0_, expr);
	vala_code_node_set_parent_node ((ValaCodeNode*) expr, (ValaCodeNode*) self);
}

/**
 * Returns the initalizer expression list
 *
 * @return expression list
 */
ValaList*
vala_initializer_list_get_initializers (ValaInitializerList* self)
{
	ValaList* _tmp0_;
	ValaList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->initializers;
	result = _tmp0_;
	return result;
}

gint
vala_initializer_list_get_size (ValaInitializerList* self)
{
	gint result;
	ValaList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->initializers;
	_tmp1_ = vala_collection_get_size ((ValaCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

/**
 * Creates a new initializer
 *
 * @param source_reference reference to source code
 * @return                 newly created initializer list
 */
ValaInitializerList*
vala_initializer_list_construct (GType object_type,
                                 ValaSourceReference* source_reference)
{
	ValaInitializerList* self = NULL;
	g_return_val_if_fail (source_reference != NULL, NULL);
	self = (ValaInitializerList*) vala_expression_construct (object_type);
	vala_code_node_set_source_reference ((ValaCodeNode*) self, source_reference);
	return self;
}

ValaInitializerList*
vala_initializer_list_new (ValaSourceReference* source_reference)
{
	return vala_initializer_list_construct (VALA_TYPE_INITIALIZER_LIST, source_reference);
}

static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}

static void
vala_initializer_list_real_accept_children (ValaCodeNode* base,
                                            ValaCodeVisitor* visitor)
{
	ValaInitializerList * self;
	self = (ValaInitializerList*) base;
	g_return_if_fail (visitor != NULL);
	{
		ValaList* _expr_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _expr_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _expr_index = 0;
		_tmp0_ = self->priv->initializers;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_expr_list = _tmp1_;
		_tmp2_ = _expr_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_expr_size = _tmp4_;
		_expr_index = -1;
		while (TRUE) {
			ValaExpression* expr = NULL;
			ValaList* _tmp5_;
			gpointer _tmp6_;
			ValaExpression* _tmp7_;
			_expr_index = _expr_index + 1;
			if (!(_expr_index < _expr_size)) {
				break;
			}
			_tmp5_ = _expr_list;
			_tmp6_ = vala_list_get (_tmp5_, _expr_index);
			expr = (ValaExpression*) _tmp6_;
			_tmp7_ = expr;
			vala_code_node_accept ((ValaCodeNode*) _tmp7_, visitor);
			_vala_code_node_unref0 (expr);
		}
		_vala_iterable_unref0 (_expr_list);
	}
}

static void
vala_initializer_list_real_accept (ValaCodeNode* base,
                                   ValaCodeVisitor* visitor)
{
	ValaInitializerList * self;
	self = (ValaInitializerList*) base;
	g_return_if_fail (visitor != NULL);
	vala_code_visitor_visit_initializer_list (visitor, self);
	vala_code_visitor_visit_expression (visitor, (ValaExpression*) self);
}

static gboolean
vala_initializer_list_real_is_constant (ValaExpression* base)
{
	ValaInitializerList * self;
	gboolean result = FALSE;
	self = (ValaInitializerList*) base;
	{
		ValaList* _initializer_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _initializer_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _initializer_index = 0;
		_tmp0_ = self->priv->initializers;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_initializer_list = _tmp1_;
		_tmp2_ = _initializer_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_initializer_size = _tmp4_;
		_initializer_index = -1;
		while (TRUE) {
			ValaExpression* initializer = NULL;
			ValaList* _tmp5_;
			gpointer _tmp6_;
			ValaExpression* _tmp7_;
			_initializer_index = _initializer_index + 1;
			if (!(_initializer_index < _initializer_size)) {
				break;
			}
			_tmp5_ = _initializer_list;
			_tmp6_ = vala_list_get (_tmp5_, _initializer_index);
			initializer = (ValaExpression*) _tmp6_;
			_tmp7_ = initializer;
			if (!vala_expression_is_constant (_tmp7_)) {
				result = FALSE;
				_vala_code_node_unref0 (initializer);
				_vala_iterable_unref0 (_initializer_list);
				return result;
			}
			_vala_code_node_unref0 (initializer);
		}
		_vala_iterable_unref0 (_initializer_list);
	}
	result = TRUE;
	return result;
}

static gboolean
vala_initializer_list_real_is_pure (ValaExpression* base)
{
	ValaInitializerList * self;
	gboolean result = FALSE;
	self = (ValaInitializerList*) base;
	{
		ValaList* _initializer_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _initializer_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _initializer_index = 0;
		_tmp0_ = self->priv->initializers;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_initializer_list = _tmp1_;
		_tmp2_ = _initializer_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_initializer_size = _tmp4_;
		_initializer_index = -1;
		while (TRUE) {
			ValaExpression* initializer = NULL;
			ValaList* _tmp5_;
			gpointer _tmp6_;
			ValaExpression* _tmp7_;
			_initializer_index = _initializer_index + 1;
			if (!(_initializer_index < _initializer_size)) {
				break;
			}
			_tmp5_ = _initializer_list;
			_tmp6_ = vala_list_get (_tmp5_, _initializer_index);
			initializer = (ValaExpression*) _tmp6_;
			_tmp7_ = initializer;
			if (!vala_expression_is_pure (_tmp7_)) {
				result = FALSE;
				_vala_code_node_unref0 (initializer);
				_vala_iterable_unref0 (_initializer_list);
				return result;
			}
			_vala_code_node_unref0 (initializer);
		}
		_vala_iterable_unref0 (_initializer_list);
	}
	result = TRUE;
	return result;
}

static gboolean
vala_initializer_list_real_is_accessible (ValaExpression* base,
                                          ValaSymbol* sym)
{
	ValaInitializerList * self;
	gboolean result = FALSE;
	self = (ValaInitializerList*) base;
	g_return_val_if_fail (sym != NULL, FALSE);
	{
		ValaList* _initializer_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _initializer_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _initializer_index = 0;
		_tmp0_ = self->priv->initializers;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_initializer_list = _tmp1_;
		_tmp2_ = _initializer_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_initializer_size = _tmp4_;
		_initializer_index = -1;
		while (TRUE) {
			ValaExpression* initializer = NULL;
			ValaList* _tmp5_;
			gpointer _tmp6_;
			ValaExpression* _tmp7_;
			_initializer_index = _initializer_index + 1;
			if (!(_initializer_index < _initializer_size)) {
				break;
			}
			_tmp5_ = _initializer_list;
			_tmp6_ = vala_list_get (_tmp5_, _initializer_index);
			initializer = (ValaExpression*) _tmp6_;
			_tmp7_ = initializer;
			if (!vala_expression_is_accessible (_tmp7_, sym)) {
				result = FALSE;
				_vala_code_node_unref0 (initializer);
				_vala_iterable_unref0 (_initializer_list);
				return result;
			}
			_vala_code_node_unref0 (initializer);
		}
		_vala_iterable_unref0 (_initializer_list);
	}
	result = TRUE;
	return result;
}

static gchar*
vala_initializer_list_real_to_string (ValaCodeNode* base)
{
	ValaInitializerList * self;
	GString* builder = NULL;
	GString* _tmp0_;
	gboolean first = FALSE;
	GString* _tmp16_;
	GString* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* result = NULL;
	self = (ValaInitializerList*) base;
	_tmp0_ = g_string_new ("{");
	builder = _tmp0_;
	first = TRUE;
	{
		ValaList* _initializer_list = NULL;
		ValaList* _tmp1_;
		ValaList* _tmp2_;
		gint _initializer_size = 0;
		ValaList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _initializer_index = 0;
		_tmp1_ = self->priv->initializers;
		_tmp2_ = _vala_iterable_ref0 (_tmp1_);
		_initializer_list = _tmp2_;
		_tmp3_ = _initializer_list;
		_tmp4_ = vala_collection_get_size ((ValaCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_initializer_size = _tmp5_;
		_initializer_index = -1;
		while (TRUE) {
			ValaExpression* initializer = NULL;
			ValaList* _tmp6_;
			gpointer _tmp7_;
			_initializer_index = _initializer_index + 1;
			if (!(_initializer_index < _initializer_size)) {
				break;
			}
			_tmp6_ = _initializer_list;
			_tmp7_ = vala_list_get (_tmp6_, _initializer_index);
			initializer = (ValaExpression*) _tmp7_;
			if (first) {
				GString* _tmp8_;
				ValaExpression* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				_tmp8_ = builder;
				_tmp9_ = initializer;
				_tmp10_ = vala_code_node_to_string ((ValaCodeNode*) _tmp9_);
				_tmp11_ = _tmp10_;
				g_string_append (_tmp8_, _tmp11_);
				_g_free0 (_tmp11_);
				first = FALSE;
			} else {
				GString* _tmp12_;
				ValaExpression* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				_tmp12_ = builder;
				_tmp13_ = initializer;
				_tmp14_ = vala_code_node_to_string ((ValaCodeNode*) _tmp13_);
				_tmp15_ = _tmp14_;
				g_string_append_printf (_tmp12_, ", %s", _tmp15_);
				_g_free0 (_tmp15_);
			}
			_vala_code_node_unref0 (initializer);
		}
		_vala_iterable_unref0 (_initializer_list);
	}
	_tmp16_ = builder;
	g_string_append_c (_tmp16_, '}');
	_tmp17_ = builder;
	_tmp18_ = _tmp17_->str;
	_tmp19_ = g_strdup (_tmp18_);
	result = _tmp19_;
	_g_string_free0 (builder);
	return result;
}

static void
vala_initializer_list_real_replace_expression (ValaCodeNode* base,
                                               ValaExpression* old_node,
                                               ValaExpression* new_node)
{
	ValaInitializerList * self;
	self = (ValaInitializerList*) base;
	g_return_if_fail (old_node != NULL);
	g_return_if_fail (new_node != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				ValaList* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				ValaList* _tmp5_;
				gpointer _tmp6_;
				ValaExpression* _tmp7_;
				gboolean _tmp8_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->initializers;
				_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
				_tmp4_ = _tmp3_;
				if (!(i < _tmp4_)) {
					break;
				}
				_tmp5_ = self->priv->initializers;
				_tmp6_ = vala_list_get (_tmp5_, i);
				_tmp7_ = (ValaExpression*) _tmp6_;
				_tmp8_ = _tmp7_ == old_node;
				_vala_code_node_unref0 (_tmp7_);
				if (_tmp8_) {
					ValaList* _tmp9_;
					_tmp9_ = self->priv->initializers;
					vala_list_set (_tmp9_, i, new_node);
					vala_code_node_set_parent_node ((ValaCodeNode*) new_node, (ValaCodeNode*) self);
				}
			}
		}
	}
}

static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}

static gboolean
vala_initializer_list_real_check (ValaCodeNode* base,
                                  ValaCodeContext* context)
{
	ValaInitializerList * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	ValaDataType* _tmp4_;
	ValaDataType* _tmp5_;
	gboolean _error_ = FALSE;
	ValaDataType* _tmp270_;
	ValaDataType* _tmp271_;
	gboolean result = FALSE;
	self = (ValaInitializerList*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = vala_code_node_get_checked ((ValaCodeNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = vala_code_node_get_error ((ValaCodeNode*) self);
		_tmp3_ = _tmp2_;
		result = !_tmp3_;
		return result;
	}
	vala_code_node_set_checked ((ValaCodeNode*) self, TRUE);
	_tmp4_ = vala_expression_get_target_type ((ValaExpression*) self);
	_tmp5_ = _tmp4_;
	if (_tmp5_ == NULL) {
		ValaSourceReference* _tmp6_;
		ValaSourceReference* _tmp7_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp6_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp7_ = _tmp6_;
		vala_report_error (_tmp7_, "initializer list used for unknown type");
		result = FALSE;
		return result;
	} else {
		ValaDataType* _tmp8_;
		ValaDataType* _tmp9_;
		_tmp8_ = vala_expression_get_target_type ((ValaExpression*) self);
		_tmp9_ = _tmp8_;
		if (VALA_IS_ARRAY_TYPE (_tmp9_)) {
			ValaArrayType* array_type = NULL;
			ValaDataType* _tmp10_;
			ValaDataType* _tmp11_;
			gboolean requires_constants_only = FALSE;
			ValaCodeNode* node = NULL;
			ValaCodeNode* _tmp12_;
			ValaCodeNode* _tmp13_;
			gboolean _tmp19_ = FALSE;
			gboolean _tmp20_ = FALSE;
			ValaCodeNode* _tmp21_;
			ValaCodeNode* _tmp22_;
			ValaDataType* inner_target_type = NULL;
			ValaArrayType* _tmp62_;
			gint _tmp63_;
			gint _tmp64_;
			_tmp10_ = vala_expression_get_target_type ((ValaExpression*) self);
			_tmp11_ = _tmp10_;
			array_type = G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, VALA_TYPE_ARRAY_TYPE, ValaArrayType);
			requires_constants_only = FALSE;
			_tmp12_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
			_tmp13_ = _tmp12_;
			node = _tmp13_;
			while (TRUE) {
				ValaCodeNode* _tmp14_;
				ValaCodeNode* _tmp15_;
				ValaCodeNode* _tmp16_;
				ValaCodeNode* _tmp17_;
				ValaCodeNode* _tmp18_;
				_tmp14_ = node;
				if (!(_tmp14_ != NULL)) {
					break;
				}
				_tmp15_ = node;
				if (VALA_IS_CONSTANT (_tmp15_)) {
					requires_constants_only = TRUE;
					break;
				}
				_tmp16_ = node;
				_tmp17_ = vala_code_node_get_parent_node (_tmp16_);
				_tmp18_ = _tmp17_;
				node = _tmp18_;
			}
			_tmp21_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
			_tmp22_ = _tmp21_;
			if (!VALA_IS_ARRAY_CREATION_EXPRESSION (_tmp22_)) {
				_tmp20_ = !requires_constants_only;
			} else {
				_tmp20_ = FALSE;
			}
			if (_tmp20_) {
				gboolean _tmp23_ = FALSE;
				ValaCodeNode* _tmp24_;
				ValaCodeNode* _tmp25_;
				_tmp24_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
				_tmp25_ = _tmp24_;
				if (!VALA_IS_INITIALIZER_LIST (_tmp25_)) {
					_tmp23_ = TRUE;
				} else {
					ValaCodeNode* _tmp26_;
					ValaCodeNode* _tmp27_;
					ValaDataType* _tmp28_;
					ValaDataType* _tmp29_;
					ValaTypeSymbol* _tmp30_;
					ValaTypeSymbol* _tmp31_;
					_tmp26_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
					_tmp27_ = _tmp26_;
					_tmp28_ = vala_expression_get_target_type ((ValaExpression*) G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, VALA_TYPE_INITIALIZER_LIST, ValaInitializerList));
					_tmp29_ = _tmp28_;
					_tmp30_ = vala_data_type_get_type_symbol (_tmp29_);
					_tmp31_ = _tmp30_;
					_tmp23_ = VALA_IS_STRUCT (_tmp31_);
				}
				_tmp19_ = _tmp23_;
			} else {
				_tmp19_ = FALSE;
			}
			if (_tmp19_) {
				ValaCodeNode* old_parent_node = NULL;
				ValaCodeNode* _tmp32_;
				ValaCodeNode* _tmp33_;
				ValaCodeNode* _tmp34_;
				ValaArrayCreationExpression* array_creation = NULL;
				ValaArrayType* _tmp35_;
				ValaDataType* _tmp36_;
				ValaDataType* _tmp37_;
				ValaDataType* _tmp38_;
				ValaDataType* _tmp39_;
				ValaArrayType* _tmp40_;
				gint _tmp41_;
				gint _tmp42_;
				ValaSourceReference* _tmp43_;
				ValaSourceReference* _tmp44_;
				ValaArrayCreationExpression* _tmp45_;
				ValaArrayCreationExpression* _tmp46_;
				ValaArrayCreationExpression* _tmp47_;
				ValaArrayType* _tmp48_;
				ValaDataType* _tmp49_;
				ValaDataType* _tmp50_;
				ValaDataType* _tmp51_;
				ValaDataType* _tmp52_;
				ValaArrayCreationExpression* _tmp53_;
				ValaDataType* _tmp54_;
				ValaDataType* _tmp55_;
				ValaArrayCreationExpression* _tmp56_;
				ValaDataType* _tmp57_;
				ValaDataType* _tmp58_;
				ValaCodeNode* _tmp59_;
				ValaArrayCreationExpression* _tmp60_;
				ValaArrayCreationExpression* _tmp61_;
				_tmp32_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
				_tmp33_ = _tmp32_;
				_tmp34_ = _vala_code_node_ref0 (_tmp33_);
				old_parent_node = _tmp34_;
				_tmp35_ = array_type;
				_tmp36_ = vala_array_type_get_element_type (_tmp35_);
				_tmp37_ = _tmp36_;
				_tmp38_ = vala_data_type_copy (_tmp37_);
				_tmp39_ = _tmp38_;
				_tmp40_ = array_type;
				_tmp41_ = vala_array_type_get_rank (_tmp40_);
				_tmp42_ = _tmp41_;
				_tmp43_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp44_ = _tmp43_;
				_tmp45_ = vala_array_creation_expression_new (_tmp39_, _tmp42_, self, _tmp44_);
				_tmp46_ = _tmp45_;
				_vala_code_node_unref0 (_tmp39_);
				array_creation = _tmp46_;
				_tmp47_ = array_creation;
				_tmp48_ = array_type;
				_tmp49_ = vala_array_type_get_length_type (_tmp48_);
				_tmp50_ = _tmp49_;
				_tmp51_ = vala_data_type_copy (_tmp50_);
				_tmp52_ = _tmp51_;
				vala_array_creation_expression_set_length_type (_tmp47_, _tmp52_);
				_vala_code_node_unref0 (_tmp52_);
				_tmp53_ = array_creation;
				_tmp54_ = vala_expression_get_target_type ((ValaExpression*) self);
				_tmp55_ = _tmp54_;
				vala_expression_set_target_type ((ValaExpression*) _tmp53_, _tmp55_);
				_tmp56_ = array_creation;
				_tmp57_ = vala_expression_get_formal_target_type ((ValaExpression*) self);
				_tmp58_ = _tmp57_;
				vala_expression_set_formal_target_type ((ValaExpression*) _tmp56_, _tmp58_);
				_tmp59_ = old_parent_node;
				_tmp60_ = array_creation;
				vala_code_node_replace_expression (_tmp59_, (ValaExpression*) self, (ValaExpression*) _tmp60_);
				vala_code_node_set_checked ((ValaCodeNode*) self, FALSE);
				_tmp61_ = array_creation;
				result = vala_code_node_check ((ValaCodeNode*) _tmp61_, context);
				_vala_code_node_unref0 (array_creation);
				_vala_code_node_unref0 (old_parent_node);
				return result;
			}
			_tmp62_ = array_type;
			_tmp63_ = vala_array_type_get_rank (_tmp62_);
			_tmp64_ = _tmp63_;
			if (_tmp64_ > 1) {
				ValaArrayType* inner_array_type = NULL;
				ValaArrayType* _tmp65_;
				ValaDataType* _tmp66_;
				ValaArrayType* _tmp67_;
				gint _tmp68_;
				gint _tmp69_;
				ValaArrayType* _tmp70_;
				ValaDataType* _tmp71_;
				_tmp65_ = array_type;
				_tmp66_ = vala_data_type_copy ((ValaDataType*) _tmp65_);
				inner_array_type = G_TYPE_CHECK_INSTANCE_CAST (_tmp66_, VALA_TYPE_ARRAY_TYPE, ValaArrayType);
				_tmp67_ = inner_array_type;
				_tmp68_ = vala_array_type_get_rank (_tmp67_);
				_tmp69_ = _tmp68_;
				vala_array_type_set_rank (_tmp67_, _tmp69_ - 1);
				_tmp70_ = inner_array_type;
				_tmp71_ = _vala_code_node_ref0 ((ValaDataType*) _tmp70_);
				_vala_code_node_unref0 (inner_target_type);
				inner_target_type = _tmp71_;
				_vala_code_node_unref0 (inner_array_type);
			} else {
				ValaArrayType* _tmp72_;
				ValaDataType* _tmp73_;
				ValaDataType* _tmp74_;
				ValaDataType* _tmp75_;
				_tmp72_ = array_type;
				_tmp73_ = vala_array_type_get_element_type (_tmp72_);
				_tmp74_ = _tmp73_;
				_tmp75_ = vala_data_type_copy (_tmp74_);
				_vala_code_node_unref0 (inner_target_type);
				inner_target_type = _tmp75_;
			}
			{
				ValaList* _e_list = NULL;
				ValaList* _tmp76_;
				ValaList* _tmp77_;
				gint _e_size = 0;
				ValaList* _tmp78_;
				gint _tmp79_;
				gint _tmp80_;
				gint _e_index = 0;
				_tmp76_ = vala_initializer_list_get_initializers (self);
				_tmp77_ = _vala_iterable_ref0 (_tmp76_);
				_e_list = _tmp77_;
				_tmp78_ = _e_list;
				_tmp79_ = vala_collection_get_size ((ValaCollection*) _tmp78_);
				_tmp80_ = _tmp79_;
				_e_size = _tmp80_;
				_e_index = -1;
				while (TRUE) {
					ValaExpression* e = NULL;
					ValaList* _tmp81_;
					gpointer _tmp82_;
					ValaExpression* _tmp83_;
					ValaDataType* _tmp84_;
					_e_index = _e_index + 1;
					if (!(_e_index < _e_size)) {
						break;
					}
					_tmp81_ = _e_list;
					_tmp82_ = vala_list_get (_tmp81_, _e_index);
					e = (ValaExpression*) _tmp82_;
					_tmp83_ = e;
					_tmp84_ = inner_target_type;
					vala_expression_set_target_type (_tmp83_, _tmp84_);
					_vala_code_node_unref0 (e);
				}
				_vala_iterable_unref0 (_e_list);
			}
			_vala_code_node_unref0 (inner_target_type);
		} else {
			ValaDataType* _tmp85_;
			ValaDataType* _tmp86_;
			ValaTypeSymbol* _tmp87_;
			ValaTypeSymbol* _tmp88_;
			_tmp85_ = vala_expression_get_target_type ((ValaExpression*) self);
			_tmp86_ = _tmp85_;
			_tmp87_ = vala_data_type_get_type_symbol (_tmp86_);
			_tmp88_ = _tmp87_;
			if (VALA_IS_STRUCT (_tmp88_)) {
				ValaStruct* st = NULL;
				ValaDataType* _tmp89_;
				ValaDataType* _tmp90_;
				ValaTypeSymbol* _tmp91_;
				ValaTypeSymbol* _tmp92_;
				gboolean _tmp99_ = FALSE;
				ValaCodeNode* _tmp100_;
				ValaCodeNode* _tmp101_;
				gboolean in_array_creation_initializer = FALSE;
				ValaObjectCreationExpression* struct_creation = NULL;
				ValaIterator* field_it = NULL;
				ValaStruct* _tmp150_;
				ValaList* _tmp151_;
				ValaIterator* _tmp152_;
				_tmp89_ = vala_expression_get_target_type ((ValaExpression*) self);
				_tmp90_ = _tmp89_;
				_tmp91_ = vala_data_type_get_type_symbol (_tmp90_);
				_tmp92_ = _tmp91_;
				st = G_TYPE_CHECK_INSTANCE_CAST (_tmp92_, VALA_TYPE_STRUCT, ValaStruct);
				while (TRUE) {
					ValaStruct* _tmp93_;
					ValaStruct* _tmp94_;
					ValaStruct* _tmp95_;
					ValaStruct* _tmp96_;
					ValaStruct* _tmp97_;
					ValaStruct* _tmp98_;
					_tmp93_ = st;
					_tmp94_ = vala_struct_get_base_struct (_tmp93_);
					_tmp95_ = _tmp94_;
					if (!(_tmp95_ != NULL)) {
						break;
					}
					_tmp96_ = st;
					_tmp97_ = vala_struct_get_base_struct (_tmp96_);
					_tmp98_ = _tmp97_;
					st = _tmp98_;
				}
				_tmp100_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
				_tmp101_ = _tmp100_;
				if (VALA_IS_INITIALIZER_LIST (_tmp101_)) {
					ValaCodeNode* _tmp102_;
					ValaCodeNode* _tmp103_;
					ValaCodeNode* _tmp104_;
					ValaCodeNode* _tmp105_;
					_tmp102_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
					_tmp103_ = _tmp102_;
					_tmp104_ = vala_code_node_get_parent_node (_tmp103_);
					_tmp105_ = _tmp104_;
					_tmp99_ = VALA_IS_ARRAY_CREATION_EXPRESSION (_tmp105_);
				} else {
					_tmp99_ = FALSE;
				}
				in_array_creation_initializer = _tmp99_;
				struct_creation = NULL;
				if (in_array_creation_initializer) {
					ValaSymbol* sym = NULL;
					ValaStruct* _tmp106_;
					ValaMemberAccess* ma = NULL;
					ValaSymbol* _tmp107_;
					const gchar* _tmp108_;
					const gchar* _tmp109_;
					ValaSourceReference* _tmp110_;
					ValaSourceReference* _tmp111_;
					ValaMemberAccess* _tmp112_;
					ValaMemberAccess* _tmp113_;
					ValaMemberAccess* _tmp114_;
					ValaSymbol* _tmp115_;
					ValaMemberAccess* inner = NULL;
					ValaMemberAccess* _tmp116_;
					ValaMemberAccess* _tmp117_;
					ValaMemberAccess* _tmp140_;
					ValaSourceReference* _tmp141_;
					ValaSourceReference* _tmp142_;
					ValaObjectCreationExpression* _tmp143_;
					ValaObjectCreationExpression* _tmp144_;
					ValaDataType* _tmp145_;
					ValaDataType* _tmp146_;
					ValaDataType* _tmp147_;
					ValaDataType* _tmp148_;
					ValaObjectCreationExpression* _tmp149_;
					_tmp106_ = st;
					sym = (ValaSymbol*) _tmp106_;
					_tmp107_ = sym;
					_tmp108_ = vala_symbol_get_name (_tmp107_);
					_tmp109_ = _tmp108_;
					_tmp110_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
					_tmp111_ = _tmp110_;
					_tmp112_ = vala_member_access_new_simple (_tmp109_, _tmp111_);
					ma = _tmp112_;
					_tmp113_ = ma;
					vala_member_access_set_creation_member (_tmp113_, TRUE);
					_tmp114_ = ma;
					_tmp115_ = sym;
					vala_expression_set_symbol_reference ((ValaExpression*) _tmp114_, _tmp115_);
					_tmp116_ = ma;
					_tmp117_ = _vala_code_node_ref0 (_tmp116_);
					inner = _tmp117_;
					while (TRUE) {
						gboolean _tmp118_ = FALSE;
						ValaSymbol* _tmp119_;
						ValaSymbol* _tmp120_;
						ValaSymbol* _tmp121_;
						ValaSymbol* _tmp127_;
						ValaSymbol* _tmp128_;
						ValaSymbol* _tmp129_;
						ValaMemberAccess* ma_inner = NULL;
						ValaSymbol* _tmp130_;
						const gchar* _tmp131_;
						const gchar* _tmp132_;
						ValaSourceReference* _tmp133_;
						ValaSourceReference* _tmp134_;
						ValaMemberAccess* _tmp135_;
						ValaMemberAccess* _tmp136_;
						ValaMemberAccess* _tmp137_;
						ValaMemberAccess* _tmp138_;
						ValaMemberAccess* _tmp139_;
						_tmp119_ = sym;
						_tmp120_ = vala_symbol_get_parent_symbol (_tmp119_);
						_tmp121_ = _tmp120_;
						if (_tmp121_ != NULL) {
							ValaSymbol* _tmp122_;
							ValaSymbol* _tmp123_;
							ValaSymbol* _tmp124_;
							ValaNamespace* _tmp125_;
							ValaNamespace* _tmp126_;
							_tmp122_ = sym;
							_tmp123_ = vala_symbol_get_parent_symbol (_tmp122_);
							_tmp124_ = _tmp123_;
							_tmp125_ = vala_code_context_get_root (context);
							_tmp126_ = _tmp125_;
							_tmp118_ = _tmp124_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp126_, VALA_TYPE_SYMBOL, ValaSymbol);
						} else {
							_tmp118_ = FALSE;
						}
						if (!_tmp118_) {
							break;
						}
						_tmp127_ = sym;
						_tmp128_ = vala_symbol_get_parent_symbol (_tmp127_);
						_tmp129_ = _tmp128_;
						sym = _tmp129_;
						_tmp130_ = sym;
						_tmp131_ = vala_symbol_get_name (_tmp130_);
						_tmp132_ = _tmp131_;
						_tmp133_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
						_tmp134_ = _tmp133_;
						_tmp135_ = vala_member_access_new_simple (_tmp132_, _tmp134_);
						ma_inner = _tmp135_;
						_tmp136_ = inner;
						_tmp137_ = ma_inner;
						vala_member_access_set_inner (_tmp136_, (ValaExpression*) _tmp137_);
						_tmp138_ = ma_inner;
						_tmp139_ = _vala_code_node_ref0 (_tmp138_);
						_vala_code_node_unref0 (inner);
						inner = _tmp139_;
						_vala_code_node_unref0 (ma_inner);
					}
					_tmp140_ = ma;
					_tmp141_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
					_tmp142_ = _tmp141_;
					_tmp143_ = vala_object_creation_expression_new (_tmp140_, _tmp142_);
					_vala_code_node_unref0 (struct_creation);
					struct_creation = _tmp143_;
					_tmp144_ = struct_creation;
					_tmp145_ = vala_expression_get_target_type ((ValaExpression*) self);
					_tmp146_ = _tmp145_;
					_tmp147_ = vala_data_type_copy (_tmp146_);
					_tmp148_ = _tmp147_;
					vala_expression_set_target_type ((ValaExpression*) _tmp144_, _tmp148_);
					_vala_code_node_unref0 (_tmp148_);
					_tmp149_ = struct_creation;
					vala_object_creation_expression_set_struct_creation (_tmp149_, TRUE);
					_vala_code_node_unref0 (inner);
					_vala_code_node_unref0 (ma);
				}
				_tmp150_ = st;
				_tmp151_ = vala_struct_get_fields (_tmp150_);
				_tmp152_ = vala_iterable_iterator ((ValaIterable*) _tmp151_);
				field_it = _tmp152_;
				{
					ValaList* _e_list = NULL;
					ValaList* _tmp153_;
					ValaList* _tmp154_;
					gint _e_size = 0;
					ValaList* _tmp155_;
					gint _tmp156_;
					gint _tmp157_;
					gint _e_index = 0;
					_tmp153_ = vala_initializer_list_get_initializers (self);
					_tmp154_ = _vala_iterable_ref0 (_tmp153_);
					_e_list = _tmp154_;
					_tmp155_ = _e_list;
					_tmp156_ = vala_collection_get_size ((ValaCollection*) _tmp155_);
					_tmp157_ = _tmp156_;
					_e_size = _tmp157_;
					_e_index = -1;
					while (TRUE) {
						ValaExpression* e = NULL;
						ValaList* _tmp158_;
						gpointer _tmp159_;
						ValaField* field = NULL;
						_e_index = _e_index + 1;
						if (!(_e_index < _e_size)) {
							break;
						}
						_tmp158_ = _e_list;
						_tmp159_ = vala_list_get (_tmp158_, _e_index);
						e = (ValaExpression*) _tmp159_;
						field = NULL;
						while (TRUE) {
							ValaField* _tmp160_;
							ValaIterator* _tmp161_;
							ValaIterator* _tmp171_;
							gpointer _tmp172_;
							ValaField* _tmp173_;
							ValaMemberBinding _tmp174_;
							ValaMemberBinding _tmp175_;
							_tmp160_ = field;
							if (!(_tmp160_ == NULL)) {
								break;
							}
							_tmp161_ = field_it;
							if (!vala_iterator_next (_tmp161_)) {
								ValaExpression* _tmp162_;
								ValaSourceReference* _tmp163_;
								ValaSourceReference* _tmp164_;
								ValaDataType* _tmp165_;
								ValaDataType* _tmp166_;
								gchar* _tmp167_;
								gchar* _tmp168_;
								gchar* _tmp169_;
								gchar* _tmp170_;
								vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
								_tmp162_ = e;
								_tmp163_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp162_);
								_tmp164_ = _tmp163_;
								_tmp165_ = vala_expression_get_target_type ((ValaExpression*) self);
								_tmp166_ = _tmp165_;
								_tmp167_ = vala_code_node_to_string ((ValaCodeNode*) _tmp166_);
								_tmp168_ = _tmp167_;
								_tmp169_ = g_strdup_printf ("too many expressions in initializer list for `%s'", _tmp168_);
								_tmp170_ = _tmp169_;
								vala_report_error (_tmp164_, _tmp170_);
								_g_free0 (_tmp170_);
								_g_free0 (_tmp168_);
								result = FALSE;
								_vala_code_node_unref0 (field);
								_vala_code_node_unref0 (e);
								_vala_iterable_unref0 (_e_list);
								_vala_iterator_unref0 (field_it);
								_vala_code_node_unref0 (struct_creation);
								return result;
							}
							_tmp171_ = field_it;
							_tmp172_ = vala_iterator_get (_tmp171_);
							_vala_code_node_unref0 (field);
							field = (ValaField*) _tmp172_;
							_tmp173_ = field;
							_tmp174_ = vala_field_get_binding (_tmp173_);
							_tmp175_ = _tmp174_;
							if (_tmp175_ != VALA_MEMBER_BINDING_INSTANCE) {
								_vala_code_node_unref0 (field);
								field = NULL;
							}
						}
						if (in_array_creation_initializer) {
							ValaMemberInitializer* member_init = NULL;
							ValaField* _tmp176_;
							const gchar* _tmp177_;
							const gchar* _tmp178_;
							ValaExpression* _tmp179_;
							ValaExpression* _tmp180_;
							ValaSourceReference* _tmp181_;
							ValaSourceReference* _tmp182_;
							ValaMemberInitializer* _tmp183_;
							ValaObjectCreationExpression* _tmp184_;
							ValaMemberInitializer* _tmp185_;
							_tmp176_ = field;
							_tmp177_ = vala_symbol_get_name ((ValaSymbol*) _tmp176_);
							_tmp178_ = _tmp177_;
							_tmp179_ = e;
							_tmp180_ = e;
							_tmp181_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp180_);
							_tmp182_ = _tmp181_;
							_tmp183_ = vala_member_initializer_new (_tmp178_, _tmp179_, _tmp182_);
							member_init = _tmp183_;
							_tmp184_ = struct_creation;
							_tmp185_ = member_init;
							vala_object_creation_expression_add_member_initializer (_tmp184_, _tmp185_);
							_vala_code_node_unref0 (member_init);
						} else {
							ValaExpression* _tmp186_;
							ValaField* _tmp187_;
							ValaDataType* _tmp188_;
							ValaDataType* _tmp189_;
							ValaDataType* _tmp190_;
							ValaDataType* _tmp191_;
							ValaDataType* _tmp192_;
							ValaDataType* _tmp193_;
							gboolean _tmp194_;
							gboolean _tmp195_;
							_tmp186_ = e;
							_tmp187_ = field;
							_tmp188_ = vala_variable_get_variable_type ((ValaVariable*) _tmp187_);
							_tmp189_ = _tmp188_;
							_tmp190_ = vala_data_type_copy (_tmp189_);
							_tmp191_ = _tmp190_;
							vala_expression_set_target_type (_tmp186_, _tmp191_);
							_vala_code_node_unref0 (_tmp191_);
							_tmp192_ = vala_expression_get_target_type ((ValaExpression*) self);
							_tmp193_ = _tmp192_;
							_tmp194_ = vala_data_type_get_value_owned (_tmp193_);
							_tmp195_ = _tmp194_;
							if (!_tmp195_) {
								ValaExpression* _tmp196_;
								ValaDataType* _tmp197_;
								ValaDataType* _tmp198_;
								_tmp196_ = e;
								_tmp197_ = vala_expression_get_target_type (_tmp196_);
								_tmp198_ = _tmp197_;
								vala_data_type_set_value_owned (_tmp198_, FALSE);
							}
						}
						_vala_code_node_unref0 (field);
						_vala_code_node_unref0 (e);
					}
					_vala_iterable_unref0 (_e_list);
				}
				if (in_array_creation_initializer) {
					ValaCodeNode* _tmp199_;
					ValaCodeNode* _tmp200_;
					ValaObjectCreationExpression* _tmp201_;
					ValaObjectCreationExpression* _tmp202_;
					_tmp199_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
					_tmp200_ = _tmp199_;
					_tmp201_ = struct_creation;
					vala_code_node_replace_expression (_tmp200_, (ValaExpression*) self, (ValaExpression*) _tmp201_);
					vala_code_node_set_checked ((ValaCodeNode*) self, FALSE);
					_tmp202_ = struct_creation;
					result = vala_code_node_check ((ValaCodeNode*) _tmp202_, context);
					_vala_iterator_unref0 (field_it);
					_vala_code_node_unref0 (struct_creation);
					return result;
				}
				_vala_iterator_unref0 (field_it);
				_vala_code_node_unref0 (struct_creation);
			} else {
				ValaSourceReference* _tmp203_;
				ValaSourceReference* _tmp204_;
				ValaDataType* _tmp205_;
				ValaDataType* _tmp206_;
				gchar* _tmp207_;
				gchar* _tmp208_;
				gchar* _tmp209_;
				gchar* _tmp210_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp203_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp204_ = _tmp203_;
				_tmp205_ = vala_expression_get_target_type ((ValaExpression*) self);
				_tmp206_ = _tmp205_;
				_tmp207_ = vala_code_node_to_string ((ValaCodeNode*) _tmp206_);
				_tmp208_ = _tmp207_;
				_tmp209_ = g_strdup_printf ("initializer list used for `%s', which is neither array nor struct", _tmp208_);
				_tmp210_ = _tmp209_;
				vala_report_error (_tmp204_, _tmp210_);
				_g_free0 (_tmp210_);
				_g_free0 (_tmp208_);
				result = FALSE;
				return result;
			}
		}
	}
	{
		ValaList* _expr_list = NULL;
		ValaList* _tmp211_;
		ValaList* _tmp212_;
		gint _expr_size = 0;
		ValaList* _tmp213_;
		gint _tmp214_;
		gint _tmp215_;
		gint _expr_index = 0;
		_tmp211_ = self->priv->initializers;
		_tmp212_ = _vala_iterable_ref0 (_tmp211_);
		_expr_list = _tmp212_;
		_tmp213_ = _expr_list;
		_tmp214_ = vala_collection_get_size ((ValaCollection*) _tmp213_);
		_tmp215_ = _tmp214_;
		_expr_size = _tmp215_;
		_expr_index = -1;
		while (TRUE) {
			ValaExpression* expr = NULL;
			ValaList* _tmp216_;
			gpointer _tmp217_;
			ValaExpression* _tmp218_;
			_expr_index = _expr_index + 1;
			if (!(_expr_index < _expr_size)) {
				break;
			}
			_tmp216_ = _expr_list;
			_tmp217_ = vala_list_get (_tmp216_, _expr_index);
			expr = (ValaExpression*) _tmp217_;
			_tmp218_ = expr;
			vala_code_node_check ((ValaCodeNode*) _tmp218_, context);
			_vala_code_node_unref0 (expr);
		}
		_vala_iterable_unref0 (_expr_list);
	}
	_error_ = FALSE;
	{
		ValaList* _e_list = NULL;
		ValaList* _tmp219_;
		ValaList* _tmp220_;
		gint _e_size = 0;
		ValaList* _tmp221_;
		gint _tmp222_;
		gint _tmp223_;
		gint _e_index = 0;
		_tmp219_ = vala_initializer_list_get_initializers (self);
		_tmp220_ = _vala_iterable_ref0 (_tmp219_);
		_e_list = _tmp220_;
		_tmp221_ = _e_list;
		_tmp222_ = vala_collection_get_size ((ValaCollection*) _tmp221_);
		_tmp223_ = _tmp222_;
		_e_size = _tmp223_;
		_e_index = -1;
		while (TRUE) {
			ValaExpression* e = NULL;
			ValaList* _tmp224_;
			gpointer _tmp225_;
			ValaExpression* _tmp226_;
			ValaDataType* _tmp227_;
			ValaDataType* _tmp228_;
			ValaUnaryExpression* unary = NULL;
			ValaExpression* _tmp232_;
			gboolean _tmp233_ = FALSE;
			ValaUnaryExpression* _tmp234_;
			_e_index = _e_index + 1;
			if (!(_e_index < _e_size)) {
				break;
			}
			_tmp224_ = _e_list;
			_tmp225_ = vala_list_get (_tmp224_, _e_index);
			e = (ValaExpression*) _tmp225_;
			_tmp226_ = e;
			_tmp227_ = vala_expression_get_value_type (_tmp226_);
			_tmp228_ = _tmp227_;
			if (_tmp228_ == NULL) {
				ValaExpression* _tmp229_;
				ValaSourceReference* _tmp230_;
				ValaSourceReference* _tmp231_;
				_error_ = TRUE;
				_tmp229_ = e;
				_tmp230_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp229_);
				_tmp231_ = _tmp230_;
				vala_report_error (_tmp231_, "expression type not allowed as initializer");
				_vala_code_node_unref0 (e);
				continue;
			}
			_tmp232_ = e;
			unary = VALA_IS_UNARY_EXPRESSION (_tmp232_) ? ((ValaUnaryExpression*) _tmp232_) : NULL;
			_tmp234_ = unary;
			if (_tmp234_ != NULL) {
				gboolean _tmp235_ = FALSE;
				ValaUnaryExpression* _tmp236_;
				ValaUnaryOperator _tmp237_;
				ValaUnaryOperator _tmp238_;
				_tmp236_ = unary;
				_tmp237_ = vala_unary_expression_get_operator (_tmp236_);
				_tmp238_ = _tmp237_;
				if (_tmp238_ == VALA_UNARY_OPERATOR_REF) {
					_tmp235_ = TRUE;
				} else {
					ValaUnaryExpression* _tmp239_;
					ValaUnaryOperator _tmp240_;
					ValaUnaryOperator _tmp241_;
					_tmp239_ = unary;
					_tmp240_ = vala_unary_expression_get_operator (_tmp239_);
					_tmp241_ = _tmp240_;
					_tmp235_ = _tmp241_ == VALA_UNARY_OPERATOR_OUT;
				}
				_tmp233_ = _tmp235_;
			} else {
				_tmp233_ = FALSE;
			}
			if (_tmp233_) {
			} else {
				ValaExpression* _tmp242_;
				ValaDataType* _tmp243_;
				ValaDataType* _tmp244_;
				ValaExpression* _tmp245_;
				ValaDataType* _tmp246_;
				ValaDataType* _tmp247_;
				_tmp242_ = e;
				_tmp243_ = vala_expression_get_value_type (_tmp242_);
				_tmp244_ = _tmp243_;
				_tmp245_ = e;
				_tmp246_ = vala_expression_get_target_type (_tmp245_);
				_tmp247_ = _tmp246_;
				if (!vala_data_type_compatible (_tmp244_, _tmp247_)) {
					ValaExpression* _tmp248_;
					ValaExpression* _tmp249_;
					ValaSourceReference* _tmp250_;
					ValaSourceReference* _tmp251_;
					ValaExpression* _tmp252_;
					ValaDataType* _tmp253_;
					ValaDataType* _tmp254_;
					gchar* _tmp255_;
					gchar* _tmp256_;
					ValaExpression* _tmp257_;
					ValaDataType* _tmp258_;
					ValaDataType* _tmp259_;
					gchar* _tmp260_;
					gchar* _tmp261_;
					gchar* _tmp262_;
					gchar* _tmp263_;
					_error_ = TRUE;
					_tmp248_ = e;
					vala_code_node_set_error ((ValaCodeNode*) _tmp248_, TRUE);
					_tmp249_ = e;
					_tmp250_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp249_);
					_tmp251_ = _tmp250_;
					_tmp252_ = e;
					_tmp253_ = vala_expression_get_target_type (_tmp252_);
					_tmp254_ = _tmp253_;
					_tmp255_ = vala_code_node_to_string ((ValaCodeNode*) _tmp254_);
					_tmp256_ = _tmp255_;
					_tmp257_ = e;
					_tmp258_ = vala_expression_get_value_type (_tmp257_);
					_tmp259_ = _tmp258_;
					_tmp260_ = vala_code_node_to_string ((ValaCodeNode*) _tmp259_);
					_tmp261_ = _tmp260_;
					_tmp262_ = g_strdup_printf ("Expected initializer of type `%s' but got `%s'", _tmp256_, _tmp261_);
					_tmp263_ = _tmp262_;
					vala_report_error (_tmp251_, _tmp263_);
					_g_free0 (_tmp263_);
					_g_free0 (_tmp261_);
					_g_free0 (_tmp256_);
				}
			}
			_vala_code_node_unref0 (e);
		}
		_vala_iterable_unref0 (_e_list);
	}
	if (!_error_) {
		ValaDataType* _tmp264_;
		ValaDataType* _tmp265_;
		ValaDataType* _tmp266_;
		ValaDataType* _tmp267_;
		ValaDataType* _tmp268_;
		ValaDataType* _tmp269_;
		_tmp264_ = vala_expression_get_target_type ((ValaExpression*) self);
		_tmp265_ = _tmp264_;
		_tmp266_ = vala_data_type_copy (_tmp265_);
		_tmp267_ = _tmp266_;
		vala_expression_set_value_type ((ValaExpression*) self, _tmp267_);
		_vala_code_node_unref0 (_tmp267_);
		_tmp268_ = vala_expression_get_value_type ((ValaExpression*) self);
		_tmp269_ = _tmp268_;
		vala_data_type_set_nullable (_tmp269_, FALSE);
	}
	_tmp270_ = vala_expression_get_value_type ((ValaExpression*) self);
	_tmp271_ = _tmp270_;
	if (_tmp271_ != NULL) {
		ValaDataType* _tmp272_;
		ValaDataType* _tmp273_;
		_tmp272_ = vala_expression_get_value_type ((ValaExpression*) self);
		_tmp273_ = _tmp272_;
		vala_code_node_check ((ValaCodeNode*) _tmp273_, context);
	}
	result = !_error_;
	return result;
}

static void
vala_initializer_list_real_emit (ValaCodeNode* base,
                                 ValaCodeGenerator* codegen)
{
	ValaInitializerList * self;
	self = (ValaInitializerList*) base;
	g_return_if_fail (codegen != NULL);
	{
		ValaList* _expr_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _expr_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _expr_index = 0;
		_tmp0_ = self->priv->initializers;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_expr_list = _tmp1_;
		_tmp2_ = _expr_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_expr_size = _tmp4_;
		_expr_index = -1;
		while (TRUE) {
			ValaExpression* expr = NULL;
			ValaList* _tmp5_;
			gpointer _tmp6_;
			ValaExpression* _tmp7_;
			_expr_index = _expr_index + 1;
			if (!(_expr_index < _expr_size)) {
				break;
			}
			_tmp5_ = _expr_list;
			_tmp6_ = vala_list_get (_tmp5_, _expr_index);
			expr = (ValaExpression*) _tmp6_;
			_tmp7_ = expr;
			vala_code_node_emit ((ValaCodeNode*) _tmp7_, codegen);
			_vala_code_node_unref0 (expr);
		}
		_vala_iterable_unref0 (_expr_list);
	}
	vala_code_visitor_visit_initializer_list ((ValaCodeVisitor*) codegen, self);
	vala_code_visitor_visit_expression ((ValaCodeVisitor*) codegen, (ValaExpression*) self);
}

static void
vala_initializer_list_real_get_used_variables (ValaCodeNode* base,
                                               ValaCollection* collection)
{
	ValaInitializerList * self;
	self = (ValaInitializerList*) base;
	g_return_if_fail (collection != NULL);
	{
		ValaList* _expr_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _expr_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _expr_index = 0;
		_tmp0_ = self->priv->initializers;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_expr_list = _tmp1_;
		_tmp2_ = _expr_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_expr_size = _tmp4_;
		_expr_index = -1;
		while (TRUE) {
			ValaExpression* expr = NULL;
			ValaList* _tmp5_;
			gpointer _tmp6_;
			ValaExpression* _tmp7_;
			_expr_index = _expr_index + 1;
			if (!(_expr_index < _expr_size)) {
				break;
			}
			_tmp5_ = _expr_list;
			_tmp6_ = vala_list_get (_tmp5_, _expr_index);
			expr = (ValaExpression*) _tmp6_;
			_tmp7_ = expr;
			vala_code_node_get_used_variables ((ValaCodeNode*) _tmp7_, collection);
			_vala_code_node_unref0 (expr);
		}
		_vala_iterable_unref0 (_expr_list);
	}
}

static void
vala_initializer_list_class_init (ValaInitializerListClass * klass,
                                  gpointer klass_data)
{
	vala_initializer_list_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeNodeClass *) klass)->finalize = vala_initializer_list_finalize;
	g_type_class_adjust_private_offset (klass, &ValaInitializerList_private_offset);
	((ValaCodeNodeClass *) klass)->accept_children = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_initializer_list_real_accept_children;
	((ValaCodeNodeClass *) klass)->accept = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_initializer_list_real_accept;
	((ValaExpressionClass *) klass)->is_constant = (gboolean (*) (ValaExpression*)) vala_initializer_list_real_is_constant;
	((ValaExpressionClass *) klass)->is_pure = (gboolean (*) (ValaExpression*)) vala_initializer_list_real_is_pure;
	((ValaExpressionClass *) klass)->is_accessible = (gboolean (*) (ValaExpression*, ValaSymbol*)) vala_initializer_list_real_is_accessible;
	((ValaCodeNodeClass *) klass)->to_string = (gchar* (*) (ValaCodeNode*)) vala_initializer_list_real_to_string;
	((ValaCodeNodeClass *) klass)->replace_expression = (void (*) (ValaCodeNode*, ValaExpression*, ValaExpression*)) vala_initializer_list_real_replace_expression;
	((ValaCodeNodeClass *) klass)->check = (gboolean (*) (ValaCodeNode*, ValaCodeContext*)) vala_initializer_list_real_check;
	((ValaCodeNodeClass *) klass)->emit = (void (*) (ValaCodeNode*, ValaCodeGenerator*)) vala_initializer_list_real_emit;
	((ValaCodeNodeClass *) klass)->get_used_variables = (void (*) (ValaCodeNode*, ValaCollection*)) vala_initializer_list_real_get_used_variables;
}

static void
vala_initializer_list_instance_init (ValaInitializerList * self,
                                     gpointer klass)
{
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	self->priv = vala_initializer_list_get_instance_private (self);
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (VALA_TYPE_EXPRESSION, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp0_);
	self->priv->initializers = (ValaList*) _tmp1_;
}

static void
vala_initializer_list_finalize (ValaCodeNode * obj)
{
	ValaInitializerList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_INITIALIZER_LIST, ValaInitializerList);
	_vala_iterable_unref0 (self->priv->initializers);
	VALA_CODE_NODE_CLASS (vala_initializer_list_parent_class)->finalize (obj);
}

/**
 * Represents an array or struct initializer list in the source code.
 */
static GType
vala_initializer_list_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaInitializerListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_initializer_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaInitializerList), 0, (GInstanceInitFunc) vala_initializer_list_instance_init, NULL };
	GType vala_initializer_list_type_id;
	vala_initializer_list_type_id = g_type_register_static (VALA_TYPE_EXPRESSION, "ValaInitializerList", &g_define_type_info, 0);
	ValaInitializerList_private_offset = g_type_add_instance_private (vala_initializer_list_type_id, sizeof (ValaInitializerListPrivate));
	return vala_initializer_list_type_id;
}

GType
vala_initializer_list_get_type (void)
{
	static volatile gsize vala_initializer_list_type_id__volatile = 0;
	if (g_once_init_enter (&vala_initializer_list_type_id__volatile)) {
		GType vala_initializer_list_type_id;
		vala_initializer_list_type_id = vala_initializer_list_get_type_once ();
		g_once_init_leave (&vala_initializer_list_type_id__volatile, vala_initializer_list_type_id);
	}
	return vala_initializer_list_type_id__volatile;
}

